package de.mdelab.mlstorypatterns.diagram.custom.edit.parts;



import org.eclipse.draw2d.ColorConstants;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.expressiondialogs.figures.MlstorypatternsDiagramConstants;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlstorypatterns.diagram.edit.parts.WrappingLabelEditPart;

public class CustomExpressionLabelEditPart extends WrappingLabelEditPart
{

	public CustomExpressionLabelEditPart(View view)
	{
		super(view);
	}

	/*
	 * should be similar to addNotationalListeners of:
	 * 
	 * CustomActivityEdgeGuardConstraintLabelEditPart
	 * CustomActivityFinalNodeReturnValueLabelEditPart
	 * CustomAttributeAssignmentEditPart CustomCallActionExpressionEditPart
	 * CustomCallActionExpression2EditPart CustomCallActionExpression3EditPart
	 * CustomStoryPatternExpressionLinkFeatureNameLabelEditPart
	 * CustomStoryPatternObjectClassifierLabelEditPart
	 */
//	@Override
//	protected void addNotationalListeners()
//	{
//		super.addNotationalListeners();
//		//MLExpression expr = ((AttributeAssignment) ((View) getModel()).getElement()).getAssignmentExpression();
//		//	JOptionPane.showInputDialog(expr + "ccd");
//		//EStructuralFeature feat = ((AttributeAssignment) ((View) getModel()).getElement()).getFeature();
//		
//		//this.addListenerFilter(Utility.getFilterId((MLNamedElement) feat), this, feat);
//		
//		//if (expr != null)
//		//{
//			//this.addListenerFilter(Utility.getFilterId((MLNamedElement) expr), this, expr);
////
//			/*if (expr instanceof CallActionExpression)
//			{
//				TreeIterator<EObject> it = ((CallActionExpression) expr).eAllContents();
//				for (EObject eObj; it.hasNext();)
//				{
//					eObj = it.next();
//					this.addListenerFilter(Utility.getFilterId((MLNamedElement) eObj), this, eObj);
//				}
//			}*/
//	//	}
//	}

	@Override
	protected void refreshVisuals()
	{
		super.refreshVisuals();
		updateFigure();
	}

	protected void updateFigure()
	{
		MLExpression expr = ((MLExpression) ((View) getModel()).getElement());
		//AttributeAssignment aa = 

		String text = "[[[]]]";
		//JOptionPane.showInputDialog(aa);
		if (expr != null)
		{
			text = expr+ " := ";
		}
		else
		{
			text = "[null] := ";
		}

		/*if (aa.getAssignmentExpression() != null)
		{
			text += aa.getAssignmentExpression().toString();
		}
		else
		{
			text += "[null]";
		}*/

		// if (text.length() > 50)
		// {
		// text = text.substring(0, 50);
		// text += "...";
		// }
		//JOptionPane.showInputDialog(text);
		setLabelText(text);

		 //((WrappingLabel) getFigure()).setTextWrap(true);
		//((WrappingLabel) getFigure()).setText(text);
		getFigure().setBackgroundColor(ColorConstants.blue);

		getFigure().setForegroundColor(MlstorypatternsDiagramConstants.MODIFIER_CREATE_COLOR);
	}

	/*
	 * should be similar to handleNotificationEvent of:
	 * 
	 * CustomActivityEdgeGuardConstraintLabelEditPart
	 * CustomActivityFinalNodeReturnValueLabelEditPart
	 * CustomAttributeAssignmentEditPart CustomCallActionExpressionEditPart
	 * CustomCallActionExpression2EditPart CustomCallActionExpression3EditPart
	 * CustomStoryPatternExpressionLinkFeatureNameLabelEditPart
	 * CustomStoryPatternObjectClassifierLabelEditPart
	 */
	@Override
	protected void handleNotificationEvent(Notification event)
	{
//		Object notifier = event.getNotifier();
//		Object newValue = event.getNewValue();
//		Object oldValue = event.getOldValue();
//		int eventType = event.getEventType();

		/*if ((eventType == Notification.SET || eventType == Notification.ADD)
				&& (newValue instanceof CallAction || newValue instanceof Expression || newValue instanceof CallActionParameter))
		{
			this.addListenerFilter(Utility.getFilterId((MLNamedElement) newValue), this, (EObject) newValue);
		*/	updateFigure();
		/*}
		else if (eventType == Notification.REMOVE
				&& (oldValue instanceof CallAction || oldValue instanceof Expression || oldValue instanceof CallActionParameter))
		{
			this.removeListenerFilter(Utility.getFilterId((MLNamedElement) oldValue));
			updateFigure();
		}
		else if (notifier instanceof AttributeAssignment || notifier instanceof CallAction || notifier instanceof Expression
				|| notifier instanceof CallActionParameter)
		{
			updateFigure();
		}*/

		super.handleNotificationEvent(event);
	}
}
