package de.mdelab.mlstorypatterns.diagram.custom.edit.parts;



import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.expressiondialogs.Utility;
import de.mdelab.mlstorypatterns.StoryPatternElement;
import de.mdelab.mlstorypatterns.StoryPatternObject;
import de.mdelab.mlstorypatterns.diagram.edit.parts.StoryPatternObjectNameEditPart;

public class CustomStoryPatternObjectNameLabelEditPart extends StoryPatternObjectNameEditPart
{

	public CustomStoryPatternObjectNameLabelEditPart(View view)
	{
		super(view);
	}

	@Override
	protected void handleNotificationEvent(Notification event)
	{
		if (event.getNotifier() instanceof StoryPatternObject)
		{
			Utility.adaptColor(getFigure(), ((StoryPatternElement) ((View) this.getModel()).getElement()).getModifier());
		}

		super.handleNotificationEvent(event);
	}

	@Override
	protected void refreshVisuals()
	{
		super.refreshVisuals();
		Utility.adaptColor(getFigure(), ((StoryPatternElement) ((View) this.getModel()).getElement()).getModifier());

		((WrappingLabel) getFigure()).setTextUnderline(true);
	}
}
